Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1216)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1217)
@@ -72,7 +72,7 @@
   static final int READ = 4;
   private static final AbstractDatabase dbAdapter = MetaCatUtil.dbAdapter;
 
-  private Connection conn = null;
+  private DBConnection connection = null;
   private String docid = null;
   private String updatedVersion=null;
   private String docname = null;
@@ -102,16 +102,16 @@
    * @param docid the identifier of the document to be created
    * @param readNodes flag indicating whether the xmlnodes should be read
    */
-  public DocumentImpl(Connection conn, String docid, boolean readNodes) 
+  public DocumentImpl(String docid, boolean readNodes) 
          throws McdbException 
   {
     try {
-      this.conn = conn;
+      //this.conn = conn;
       this.docid = docid;
       
       // Look up the document information
       getDocumentInfo(docid);
-
+      
       if (readNodes) {
         // Download all of the document nodes using a single SQL query
         // The sort order of the records is determined by the NodeComparator
@@ -118,6 +118,7 @@
         // class, and needs to represent a depth-first traversal for the
         // toXml() method to work properly
         nodeRecordList = getNodeRecordList(rootnodeid);
+        
       }
     
     } catch (McdbException ex) {
@@ -135,9 +136,9 @@
    * @param conn the database connection from which to read the document
    * @param docid the identifier of the document to be created
    */
-  public DocumentImpl(Connection conn, String docid) throws McdbException 
+  public DocumentImpl(String docid) throws McdbException 
   {
-    this(conn, docid, true);
+    this(docid, true);
   }
 
   /** 
@@ -164,7 +165,7 @@
    *        resides.
    *
    */
-  public DocumentImpl(Connection conn, long rootnodeid, String docname, 
+  /*public DocumentImpl(Connection conn, long rootnodeid, String docname, 
                       String doctype, String docid, String action, String user,
                       String pub, String catalogid, int serverCode)
                       throws SQLException, Exception
@@ -175,7 +176,7 @@
     this.doctype = doctype;
     this.docid = docid;
     writeDocumentToDB(action, user, pub, catalogid, serverCode);
-  }
+  }*/
   
   /** 
    * Construct a new document instance, writing the contents to the database.
@@ -206,13 +207,13 @@
    *        resides.
    *
    */
-  public DocumentImpl(Connection conn, long rootNodeId, String docName, 
+  public DocumentImpl(DBConnection conn, long rootNodeId, String docName, 
                       String docType, String docId, String newRevision, 
                       String action, String user,
                       String pub, String catalogId, int serverCode)
                       throws SQLException, Exception
   {
-    this.conn = conn;
+    this.connection = conn;
     this.rootnodeid = rootNodeId;
     this.docname = docName;
     this.doctype = docType;
@@ -228,14 +229,11 @@
                      String docname, String doctype, String accnum, String user)
                      throws SQLException, AccessionNumberException, Exception
   {
-    Connection dbConn = null;
-    MetaCatUtil ut = new MetaCatUtil();
+    
     try
     {
-      dbConn = ut.openDBConnection();
-      // get server location for this doc
-      int serverLocation=getServerLocationNumber(dbConn,accnum);
-      dbConn.close();
+       // get server location for this doc
+      int serverLocation=getServerLocationNumber(accnum);
       registerDocument(docname, doctype,accnum, user, serverLocation);
     }
     catch (Exception e)
@@ -242,15 +240,7 @@
     {
       throw e;
     }
-    finally
-    {
-      try
-      {
-        dbConn.close();
-      }
-      catch (Exception ee)
-      {}
-    }
+   
     
   }
   /**
@@ -280,20 +270,26 @@
                      String user, int serverCode)
                      throws SQLException, AccessionNumberException, Exception
   {
-    Connection dbconn = null;
-    MetaCatUtil util = new MetaCatUtil();
+    DBConnection dbconn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
+    //MetaCatUtil util = new MetaCatUtil();
     AccessionNumber ac;
     try {
-      dbconn = util.openDBConnection();
+      //dbconn = util.openDBConnection();
+      //check out DBConnection
+      dbconn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.registerDocument");
+      serialNumber=dbconn.getCheckOutSerialNumber();
       String docIdWithoutRev=MetaCatUtil.getDocIdFromString(accnum);
       int userSpecifyRev=MetaCatUtil.getVersionFromString(accnum);
-      int revInDataBase=getLatestRevisionNumber(dbconn, docIdWithoutRev);
+      int revInDataBase=getLatestRevisionNumber(docIdWithoutRev);
       //revIndataBase=-1, there is no record in xml_documents table
       //the data file is a new one, inert it into table
       //user specified rev should be great than 0
       if (revInDataBase==-1 && userSpecifyRev>0 )
       {
-        ac = new AccessionNumber(dbconn, accnum, "insert");
+        ac = new AccessionNumber(accnum, "insert");
       }
       //rev is greater the last revsion number and revInDataBase isn't -1
       // it is a updated data file
@@ -301,10 +297,10 @@
       {
         
         //archive the old entry 
-        archiveDocRevision(dbconn, docIdWithoutRev, user);
+        archiveDocRevision(docIdWithoutRev, user);
         //delete the old entry in xml_documents
-        deleteXMLDocuments(dbconn, docIdWithoutRev);
-        ac = new AccessionNumber(dbconn, accnum, "update");
+        deleteXMLDocuments(docIdWithoutRev);
+        ac = new AccessionNumber(accnum, "update");
       }
       //other situation
       else
@@ -336,21 +332,20 @@
       sql.append(sqlDateString).append(",");
       sql.append(sqlDateString).append(",");
       sql.append("'0')");
-      PreparedStatement pstmt = dbconn.prepareStatement(sql.toString());
+      pstmt = dbconn.prepareStatement(sql.toString());
       pstmt.execute();
       pstmt.close();
-      dbconn.close();
+      //dbconn.close();
     } 
     finally 
     {
       try
       {
-        dbconn.close();
+        pstmt.close();
       }
-      catch (SQLException sqlE)
+      finally
       {
-        util.debugMessage("Error in DocumentImpl.registerDocument:" +
-                                sqlE.getMessage(), 30);
+        DBConnectionPool.returnDBConnection(dbconn, serialNumber);
       }
     }    
   }
@@ -385,14 +380,19 @@
                      String user, int serverCode)
                      throws SQLException, AccessionNumberException, Exception
   {
-    Connection dbconn = null;
-    MetaCatUtil util = new MetaCatUtil();
+    DBConnection dbconn = null;
+    int serialNumber = -1;
+    //MetaCatUtil util = new MetaCatUtil();
     AccessionNumber ac;
+    PreparedStatement pstmt = null;
     try {
-      dbconn = util.openDBConnection();
+      //dbconn = util.openDBConnection();
+       dbconn=DBConnectionPool.
+                  getDBConnection("DocumentImpl.registerDocumentInReplication");
+      serialNumber=dbconn.getCheckOutSerialNumber();
       String docIdWithoutRev=MetaCatUtil.getDocIdFromString(accnum);
       int userSpecifyRev=MetaCatUtil.getVersionFromString(accnum);
-      int revInDataBase=getLatestRevisionNumber(dbconn, docIdWithoutRev);
+      int revInDataBase=getLatestRevisionNumber(docIdWithoutRev);
       //revIndataBase=-1, there is no record in xml_documents table
       //the data file is a new one, inert it into table
       //user specified rev should be great than 0
@@ -399,7 +399,7 @@
       if (revInDataBase==-1 && userSpecifyRev>0 )
       {
        
-        ac = new AccessionNumber(dbconn, accnum, "insert");
+        ac = new AccessionNumber(accnum, "insert");
       }
       //rev is greater the last revsion number and revInDataBase isn't -1
       // it is a updated data file
@@ -407,10 +407,10 @@
       {
         
         //archive the old entry 
-        archiveDocRevision(dbconn, docIdWithoutRev, user);
+        archiveDocRevision(docIdWithoutRev, user);
         //delete the old entry in xml_documents
-        deleteXMLDocuments(dbconn, docIdWithoutRev);
-        ac = new AccessionNumber(dbconn, accnum, "update");
+        deleteXMLDocuments(docIdWithoutRev);
+        ac = new AccessionNumber(accnum, "update");
       }
       //other situation
       else
@@ -442,22 +442,15 @@
       sql.append(sqlDateString).append(",");
       sql.append(sqlDateString).append(",");
       sql.append("'0')");
-      PreparedStatement pstmt = dbconn.prepareStatement(sql.toString());
+      pstmt = dbconn.prepareStatement(sql.toString());
       pstmt.execute();
       pstmt.close();
-      dbconn.close();
+      //dbconn.close();
     } 
     finally 
     {
-      try
-      {
-        dbconn.close();
-      }
-      catch (SQLException sqlE)
-      {
-        util.debugMessage("Error in DocumentImpl.registerDocument:" +
-                                sqlE.getMessage());
-      }
+      pstmt.close();
+      DBConnectionPool.returnDBConnection(dbconn, serialNumber);
     }    
   }
   
@@ -539,23 +532,17 @@
   public static boolean getDataFileLockGrant(String accnum) 
                                                   throws Exception
   { 
-    Connection dbConn = null;
-    MetaCatUtil ut= new MetaCatUtil();
+    
     try
     {
-      dbConn = ut.openDBConnection();
-      int serverLocation=getServerLocationNumber(dbConn,accnum);
-      dbConn.close();
+      
+      int serverLocation=getServerLocationNumber(accnum);
+    
       return getDataFileLockGrant(accnum,serverLocation);
     }
     catch (Exception e)
     {
-      try
-      {
-        dbConn.close();
-      }
-      catch (Exception ee)
-      {}
+     
       throw e;
     }
   }
@@ -574,9 +561,9 @@
                                           throws Exception 
   {
     boolean flag=true;
-    MetaCatUtil util = new MetaCatUtil();
-    String docid = util.getDocIdFromString(accnum);
-    int rev = util.getVersionFromString(accnum);
+    //MetaCatUtil util = new MetaCatUtil();
+    String docid = MetaCatUtil.getDocIdFromString(accnum);
+    int rev = MetaCatUtil.getVersionFromString(accnum);
     
     if (serverCode == 1)
     {
@@ -594,8 +581,8 @@
       
       String server = MetacatReplication.getServer(serverCode);
       MetacatReplication.replLog("attempting to lock " + accnum);
-      URL u = new URL("https://" + server + "?server="
-           +util.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
+      URL u = new URL("https://" + server + "?server=" +
+        MetaCatUtil.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
            +rev + "&docid=" + docid);
       //System.out.println("sending message: " + u.toString());
       String serverResStr = MetacatReplication.getURLContent(u);
@@ -940,41 +927,54 @@
   private boolean isRevisionOnly(DocumentIdentifier docid) throws Exception
   {
     //System.out.println("inRevisionOnly");
-    PreparedStatement pstmt;
+    DBConnection dbconn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt =null;
     String rev = docid.getRev();
     String newid = docid.getIdentifier();
-    pstmt = conn.prepareStatement("select rev from xml_documents " +
+    try
+    {
+      dbconn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.isRevisionOnly");
+      serialNumber=dbconn.getCheckOutSerialNumber();
+      pstmt = dbconn.prepareStatement("select rev from xml_documents " +
                                   "where docid like '" + newid + "'");
-    pstmt.execute();
-    ResultSet rs = pstmt.getResultSet();
-    boolean tablehasrows = rs.next();
-    if(rev.equals("newest") || rev.equals("all"))
-    {
-      return false;
-    }
-    
-    if(tablehasrows)
-    {
-      int r = rs.getInt(1);
-      pstmt.close();
-      if(new Integer(rev).intValue() == r)
-      { //the current revision in in xml_documents
-        //System.out.println("returning false");
+      pstmt.execute();
+      ResultSet rs = pstmt.getResultSet();
+      boolean tablehasrows = rs.next();
+      if(rev.equals("newest") || rev.equals("all"))
+      {
         return false;
       }
-      else if(new Integer(rev).intValue() < r)
-      { //the current revision is in xml_revisions.
-        //System.out.println("returning true");
-        return true;
-      }
-      else if(new Integer(rev).intValue() > r)
-      { //error, rev cannot be greater than r
-        throw new Exception("requested revision cannot be greater than " +
+    
+      if(tablehasrows)
+      {
+        int r = rs.getInt(1);
+        pstmt.close();
+        if(new Integer(rev).intValue() == r)
+        { //the current revision in in xml_documents
+          //System.out.println("returning false");
+          return false;
+        }
+        else if(new Integer(rev).intValue() < r)
+        { //the current revision is in xml_revisions.
+          //System.out.println("returning true");
+          return true;
+        }
+        else if(new Integer(rev).intValue() > r)
+        { //error, rev cannot be greater than r
+          throw new Exception("requested revision cannot be greater than " +
                             "the latest revision number.");
+        }
       }
-    }
-    throw new Exception("the requested docid '" + docid.toString() + 
+      throw new Exception("the requested docid '" + docid.toString() + 
                         "' does not exist");
+    }//try
+    finally
+    {
+      pstmt.close();
+      DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+    }//finally
   }
 
   private void getDocumentInfo(String docid) throws McdbException, 
@@ -990,7 +990,9 @@
    */
   private void getDocumentInfo(DocumentIdentifier docid) throws McdbException 
   {
-    PreparedStatement pstmt;
+    DBConnection dbconn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
     String table = "xml_documents";
         
     try
@@ -1013,7 +1015,10 @@
       
     }
     
-    try {
+    try 
+    {
+      dbconn=DBConnectionPool.getDBConnection("DocumentImpl.getDocumentInfo");
+      serialNumber=dbconn.getCheckOutSerialNumber();
       StringBuffer sql = new StringBuffer();
 // DOCTITLE attr cleared from the db
 //      sql.append("SELECT docname, doctype, rootnodeid, doctitle, ");
@@ -1025,7 +1030,7 @@
       sql.append("' and rev like '").append(docid.getRev()).append("'");
       //System.out.println(sql.toString());
       pstmt =
-        conn.prepareStatement(sql.toString());
+        dbconn.prepareStatement(sql.toString());
       // Bind the values to the query
       //pstmt.setString(1, docid.getIdentifier());
       //pstmt.setString(2, docid.getRev());
@@ -1051,10 +1056,10 @@
       
       //get doc  home server name
       
-      pstmt = conn.prepareStatement("select server " +
+      pstmt = dbconn.prepareStatement("select server " +
                         "from xml_replication where serverid = ?");
-                        
-      
+      //because connection use twise here, so we need to increase one
+      dbconn.increaseUsageCount(1);
       pstmt.setInt(1, serverlocation);
       pstmt.execute();
       rs = pstmt.getResultSet();
@@ -1078,9 +1083,11 @@
       pstmt.close();
       if (this.doctype != null) {
         pstmt =
-          conn.prepareStatement("SELECT system_id " +
+          dbconn.prepareStatement("SELECT system_id " +
                                   "FROM xml_catalog " +
                                  "WHERE public_id = ?");
+        //should increase usage count again
+        dbconn.increaseUsageCount(1);
         // Bind the values to the query
         pstmt.setString(1, doctype);
   
@@ -1099,6 +1106,22 @@
       throw new McdbException("Error accessing database connection in " +
                               "DocumentImpl.getDocumentInfo: ", e);
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("error in DocumentImple.getDocumentInfo: "
+                                    +ee.getMessage(), 30);
+      }//catch
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+      }
+    }
 
     if (this.docname == null) {
       throw new McdbDocNotFoundException("Document not found: " + docid);
@@ -1110,9 +1133,11 @@
    *
    * @param rootnodeid the id of the root node of the node tree to look up
    */
-  private TreeSet getNodeRecordList(long rootnodeid) throws McdbException 
+  private TreeSet getNodeRecordList(long rootnodeid) throws McdbException
   {
-    PreparedStatement pstmt;
+    PreparedStatement pstmt = null;
+    DBConnection dbconn = null;
+    int serialNumber = -1;
     TreeSet nodeRecordList = new TreeSet(new NodeComparator());
     long nodeid = 0;
     long parentnodeid = 0;
@@ -1124,8 +1149,11 @@
     String quotechar = dbAdapter.getStringDelimiter();
 
     try {
+      dbconn=DBConnectionPool.
+                    getDBConnection("DocumentImpl.getNodeRecordList");
+      serialNumber=dbconn.getCheckOutSerialNumber();
       pstmt =
-      conn.prepareStatement("SELECT nodeid,parentnodeid,nodeindex, " +
+      dbconn.prepareStatement("SELECT nodeid,parentnodeid,nodeindex, " +
            "nodetype,nodename,nodeprefix,nodedata " +               
            "FROM xml_nodes WHERE rootnodeid = ?");
 
@@ -1158,6 +1186,23 @@
       throw new McdbException("Error in DocumentImpl.getNodeRecordList " +
                               e.getMessage());
     }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+      }
+      catch (SQLException ee)
+      {
+        MetaCatUtil.debugMessage("error in DocumentImpl.getNodeRecordList: "
+                                    +ee.getMessage(), 30);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbconn, serialNumber);
+      }
+    }
+      
 
     if (nodeRecordList != null) {
       return nodeRecordList;
@@ -1187,8 +1232,8 @@
       if (action.equals("INSERT")) {
         //AccessionNumber ac = new AccessionNumber();
         //this.docid = ac.generate(docid, "INSERT");
-        System.out.println("before pstmt");
-        pstmt = conn.prepareStatement(
+        
+        pstmt = connection.prepareStatement(
                 "INSERT INTO xml_documents " +
                 "(docid, rootnodeid, docname, doctype, " + 
                 "user_owner, user_updated, date_created, date_updated, " + 
@@ -1195,6 +1240,9 @@
                 "public_access, catalog_id, server_location, rev) " +
                 "VALUES (?, ?, ?, ?, ?, ?, " + sysdate + ", " + sysdate + 
                 ", ?, ?, ?, ?)");
+        // Increase dbconnection usage count
+        connection.increaseUsageCount(1);
+        
         //note that the server_location is set to 1. 
         //this means that "localhost" in the xml_replication table must
         //always be the first entry!!!!!
@@ -1221,8 +1269,8 @@
       } else if (action.equals("UPDATE")) {
 
         // Save the old document publicaccessentry in a backup table
-        DocumentImpl.archiveDocRevision( conn, docid, user );
-        DocumentImpl thisdoc = new DocumentImpl(conn, docid);
+        DocumentImpl.archiveDocRevision(connection, docid, user );
+        DocumentImpl thisdoc = new DocumentImpl(docid);
         int thisrev = thisdoc.getRev();
         
         //if the updated vesion is not greater than current one,
@@ -1240,18 +1288,23 @@
         
         // Delete index for the old version of docid
         // The new index is inserting on the next calls to DBSAXNode
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
                 "DELETE FROM xml_index WHERE docid='" + this.docid + "'");
+        // Increase dbconnection usage count
+        connection.increaseUsageCount(1);
+        
         pstmt.execute();
         pstmt.close();
 
         // Update the new document to reflect the new node tree
-        pstmt = conn.prepareStatement(
+        pstmt = connection.prepareStatement(
             "UPDATE xml_documents " +
             "SET rootnodeid = ?, docname = ?, doctype = ?, " +
             "user_updated = ?, date_updated = " + sysdate + ", " +
             "server_location = ?, rev = ?, public_access = ?, catalog_id = ? " +
             "WHERE docid = ?");
+        // Increase dbconnection usage count
+        connection.increaseUsageCount(1);
         // Bind the values to the query
         pstmt.setLong(1, rootnodeid);
         pstmt.setString(2, docname);
@@ -1276,7 +1329,7 @@
 
       // Do the insertion
       pstmt.execute();
-      System.out.println("after excecute");
+      
       pstmt.close();
 
     } catch (SQLException sqle) {
@@ -1298,7 +1351,7 @@
    * @param user the user that owns the document
    * @param groups the groups to which user belongs
    */
-  public static String write(Connection conn,String filename,
+  public static String write(DBConnection conn,String filename,
                              String pub, String dtdfilename,
                              String action, String docid, String user,
                              String[] groups )
@@ -1312,7 +1365,7 @@
                    pub, dtd, action, docid, user, groups, false);
   }
 
-  public static String write(Connection conn,Reader xml,String pub,Reader dtd,
+  public static String write(DBConnection conn,Reader xml,String pub,Reader dtd,
                              String action, String docid, String user,
                              String[] groups, boolean validate)
                 throws Exception {
@@ -1319,13 +1372,13 @@
     //this method will be called in handleUpdateOrInsert method 
     //in MetacatServlet class
     // get server location for this doc
-    int serverLocation=getServerLocationNumber(conn,docid);
+    int serverLocation=getServerLocationNumber(docid);
     //System.out.println("server location: "+serverLocation);
     return write(conn,xml,pub,dtd,action,docid,user,groups,serverLocation,false,
                  validate);
   }
 
-  public static String write(Connection conn, Reader xml, String pub,
+  public static String write(DBConnection conn, Reader xml, String pub,
                              String action, String docid, String user,
                              String[] groups )
                 throws Exception {
@@ -1332,7 +1385,7 @@
     if(action.equals("UPDATE"))
     {//if the document is being updated then use the servercode from the 
      //originally inserted document.
-      DocumentImpl doc = new DocumentImpl(conn, docid);
+      DocumentImpl doc = new DocumentImpl(docid);
       int servercode = doc.getServerlocation();
       return write(conn, xml, pub, action, docid, user, groups, servercode);
     }
@@ -1342,7 +1395,7 @@
     }
   }
   
-  public static String write( Connection conn, Reader xml,
+  public static String write(DBConnection conn, Reader xml,
                               String action, String docid, String user,
                               String[] groups, int serverCode )
                 throws Exception
@@ -1350,7 +1403,7 @@
     return write(conn,xml,null,action,docid,user,groups,serverCode);
   }
   
-  public static String write( Connection conn, Reader xml, String pub,
+  public static String write(DBConnection conn, Reader xml, String pub,
                               String action, String docid, String user,
                               String[] groups, int serverCode) 
                 throws Exception
@@ -1359,7 +1412,7 @@
                  serverCode,false,false);
   }
   
-  public static String write( Connection conn, Reader xml, String pub,
+  public static String write(DBConnection conn, Reader xml, String pub,
                               String action, String docid, String user,
                               String[] groups, int serverCode, boolean override)
                 throws Exception
@@ -1388,15 +1441,17 @@
    *        update will be locked and version checked.
    */
 
-  public static String write( Connection conn,Reader xml,String pub,Reader dtd,
-                              String action, String accnum, String user,
-                              String[] groups, int serverCode, boolean override,
-                              boolean validate)
+  public static String write(DBConnection conn, Reader xml,String pub,
+                         Reader dtd, String action, String accnum, String user,
+                         String[] groups, int serverCode, boolean override,
+                         boolean validate)
                 throws Exception
   {
     // NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
-    MetaCatUtil util = new MetaCatUtil();
-    AccessionNumber ac = new AccessionNumber(conn, accnum, action);
+    //MetaCatUtil util = new MetaCatUtil();
+    MetaCatUtil.debugMessage("conn usage count before writting: "
+                                      +conn.getUsageCount(), 50);
+    AccessionNumber ac = new AccessionNumber(accnum, action);
     String docid = ac.getDocid();
     String rev = ac.getRev();
     MetaCatUtil.debugMessage("action: " + action + " servercode: " + 
@@ -1412,7 +1467,7 @@
       char istreamChar;
      
       // check for 'write' permission for 'user' to update this document
-      if ( !hasPermission(conn, user, groups, docid) ) {
+      if ( !hasPermission(user, groups, docid) ) {
         throw new Exception("User " + user + 
               " does not have permission to update XML Document #" + accnum);
       }        
@@ -1421,8 +1476,8 @@
       String updaterev = id.getRev();
       String server = MetacatReplication.getServer(serverCode);
       MetacatReplication.replLog("attempting to lock " + accnum);
-      URL u = new URL("https://" + server + "?server="
-           +util.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
+      URL u = new URL("https://" + server + "?server="+
+        MetaCatUtil.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
            +updaterev + "&docid=" + docid);
       //System.out.println("sending message: " + u.toString());
       String serverResStr = MetacatReplication.getURLContent(u);
@@ -1452,10 +1507,10 @@
         
         //If Metacat is super hub, tell all servers in its server list to get 
         //the new document, ture mean it is xml document
-        if ((util.getOption("hub")).equals("super"))
+        if ((MetaCatUtil.getOption("hub")).equals("super"))
         {
           ForceReplicationHandler frh = new ForceReplicationHandler(accnum, 
-                true, ReplicationHandler.buildServerList(conn));
+                true, ReplicationHandler.buildServerList());
         }
         else
         {
@@ -1495,7 +1550,7 @@
     if ( action.equals("UPDATE") ) {
       // check for 'write' permission for 'user' to update this document
 
-      if ( !hasPermission(conn, user, groups, docid) ) {
+      if ( !hasPermission(user, groups, docid) ) {
         throw new Exception("User " + user + 
               " does not have permission to update XML Document #" + accnum);
       }          
@@ -1506,6 +1561,7 @@
       
       XMLReader parser = initializeParser(conn, action, docid, rev, validate,
                                           user, groups, pub, serverCode, dtd);
+   
       conn.setAutoCommit(false);
       parser.parse(new InputSource(xml));
       conn.commit();
@@ -1525,10 +1581,11 @@
       //start the thread to replicate this new document out to the other servers
       //true mean it is xml document
       ForceReplicationHandler frh = new ForceReplicationHandler
-                (accnum, action, true,ReplicationHandler.buildServerList(conn));
+                (accnum, action, true,ReplicationHandler.buildServerList());
       
     }
-      
+    MetaCatUtil.debugMessage("Conn Usage count after writting: "
+                                                      +conn.getUsageCount(),50); 
     return(accnum);
   }
 
@@ -1547,22 +1604,19 @@
    * @param validate, if the xml document is valid or not
    */
 
-  public static String writeReplication( Connection conn,Reader xml,String pub,
-                Reader dtd, String action, String accnum, String user,
-                            String[] groups,String homeServer, boolean validate)
+  public static String writeReplication(DBConnection conn, Reader xml, 
+            String pub, Reader dtd, String action, String accnum, String user,
+            String[] groups,String homeServer, boolean validate)
                 throws Exception
   {
-    // NEW - WHEN CLIENT ALWAYS PROVIDE ACCESSION NUMBER INCLUDING REV IN IT
-    MetaCatUtil util = new MetaCatUtil();
-    //AccessionNumber ac = new AccessionNumber(conn, accnum, action);
-    //String docid = ac.getDocid();
-    // String rev = ac.getRev();
-    String docid=util.getDocIdFromString(accnum);
-    String rev=(new Integer(util.getVersionFromString(accnum))).toString();
+   
+    String docid=MetaCatUtil.getDocIdFromString(accnum);
+    String rev=(new Integer(MetaCatUtil.getVersionFromString(accnum))).
+                                                                    toString();
     
     //check if xml_documents table has the document or not
     //if not, set action to insert
-    if (getLatestRevisionNumber(conn,docid)==-1)
+    if (getLatestRevisionNumber(docid)==-1)
     {
       action="INSERT";
     }
